<?php 


class MdlListe{

    private $con; 

    public function __construct(){ 
        global $rep,$vues,$dsn,$login,$password;
        $this->con = new Connection($dsn, $login, $password); 
    }
    

    public function insert(string $name, bool $private, ?User $creator): Liste{
        $gate=new ListeGateway($this->con);
        $l=new Liste(0, $name, $private, $creator, []);
        $gate->insert($l);
        $id=$gate->getLastId();
        $l->setId($id[0]['oldId']);
        return $l;
    }

    public function delete(Liste $liste){
        $gate=new ListeGateway($this->con);
        $gate->delete($liste);
    }

    public function update(Liste $liste, string $name, bool $private){
        $gate=new ListeGateway($this->con);
        $liste->setName($name);
        if ($liste->getCreator()!=null){
            $liste->setPrivate($private);
        }
        $gate->update($liste);
    }

    public function findByName(string $name, ?User $u): array{
        $gate=new ListeGateway($this->con);
        $gateTache=new TacheGateway($this->con);
        $results=$gate->findByName($name);
        $tabListe=[];
        foreach ($results as $row ) {
            $tabTache=[];
            $taches=$gateTache->getTacheFromIdList($row['id']);
            foreach($taches as $tata){
                $tabTache[]=new Tache($tata['id'], $tata['name'], $tata['content'], $tata['completed']);
            }
            if ($row['private']==false){
                $tabListe[]=new Liste($row['id'], $row['name'], $row['private'], null, $tabTache);
            }
            if ($row['idCreator']==$u->getId()){
                $tabListe[]=new Liste($row['id'], $row['name'], $row['private'], $u, $tabTache);
            }
        }
        return $tabListe;
    }

    public function findById(string $id): array{
        $gate=new ListeGateway($this->con);
        $gateTache=new TacheGateway($this->con);
        $results=$gate->findById($id);
        $tabListe=[];
        foreach ($results as $row ) {
            $tabTache=[];
            $taches=$gateTache->getTacheFromIdList($row['id']);
            foreach($taches as $tata){
                $tabTache[]=new Tache($tata['id'], $tata['name'], $tata['content'], $tata['completed']);
            }
            $tabListe[]=new Liste($row['id'], $row['name'], $row['private'], null, $tabTache);
        }
        return $tabListe;
    }

    public function findByUser(string $username): array{
        $gate=new ListeGateway($this->con);
        $gateTache=new TacheGateway($this->con);
        $gateUser=new UserGateway($this->con);

        $id=$gateUser->findByName($username);
        $id=$id['id'];
        $results=$gate->findByUserId($id);
        $tabListe=[];
        foreach ($results as $row ) {
            $tabTache=[];
            $taches=$gateTache->getTacheFromIdList($row['id']);
            foreach($taches as $tata){
                $tabTache[]=new Tache($tata['id'], $tata['name'], $tata['content'], $tata['completed']);
            }
            $tabListe[]=new Liste($row['id'], $row['name'], $row['private'], $u, $tabTache);
        }
        return $tabListe;
    }

    public function getPublicList(){
        $gate=new ListeGateway($this->con);
        return $gate->getPublicList();
    }
    
}

?>